#version 120
#extension GL_EXT_geometry_shader4: enable
varying in vec4 normal[];
uniform  float normalSize;
uniform  vec4 vertNormalColour;
uniform  vec4 faceNormalColour;
uniform bool drawFaceNormals;
uniform bool drawVertexNormals;
varying out vec4 perNormalColour;

void main()
{
	if (drawVertexNormals == true)
	{
		perNormalColour=vertNormalColour;

		for(int i = 0; i<gl_VerticesIn; ++i)
		{
			gl_Position = gl_PositionIn[i];
			EmitVertex();
			gl_Position = gl_PositionIn[i] + normal[i] * abs(normalSize);
			EmitVertex();
			EndPrimitive();
		}
	}
	if (drawFaceNormals == true)
	{
		perNormalColour=faceNormalColour;

		vec4 cent = (gl_PositionIn[0] + gl_PositionIn[1] + gl_PositionIn[2]) / 3.0;
		vec3 face_normal = normalize(cross(gl_PositionIn[2].xyz - gl_PositionIn[0].xyz,

																 gl_PositionIn[1].xyz - gl_PositionIn[0].xyz));

		gl_Position =  cent;
		EmitVertex();
		gl_Position =  (cent + vec4(face_normal * abs(normalSize), 0.0));
		EmitVertex();
		EndPrimitive();
	}
}


